﻿@model IEnumerable<RoomEscapeCatalog.Models.Room>

@{
    ViewBag.Title = "Escape Room Series";

    var difficultyMinVal = Request.QueryString.Get("difficultyMin");
    difficultyMinVal = String.IsNullOrWhiteSpace(difficultyMinVal) ? "1" : difficultyMinVal;

    var difficultyMaxVal = Request.QueryString.Get("difficultyMax");
    difficultyMaxVal = String.IsNullOrWhiteSpace(difficultyMaxVal) ? "5" : difficultyMaxVal;

    var creepinessMinVal = Request.QueryString.Get("creepinessMin");
    creepinessMinVal = String.IsNullOrWhiteSpace(creepinessMinVal) ? "1" : creepinessMinVal;

    var creepinessMaxVal = Request.QueryString.Get("creepinessMax");
    creepinessMaxVal = String.IsNullOrWhiteSpace(creepinessMaxVal) ? "5" : creepinessMaxVal;

    var groupSizeMinVal = Request.QueryString.Get("groupSizeMin");
    groupSizeMinVal = String.IsNullOrWhiteSpace(groupSizeMinVal) ? "1" : groupSizeMinVal;

    var groupSizeMaxVal = Request.QueryString.Get("groupSizeMax");
    groupSizeMaxVal = String.IsNullOrWhiteSpace(groupSizeMaxVal) ? "20" : groupSizeMaxVal;

    var roomsAll = ViewBag.RoomsAll == null ? Model : (ViewBag.RoomsAll as IEnumerable<RoomEscapeCatalog.Models.Room>);
    var topThreeRooms = roomsAll.OrderBy(r => r.Rating).Take(3);
}


<div class="mt-2">
    @Html.Partial("_TopRoomsCarousel", topThreeRooms)
</div>

<div class="rooms-and-filter-container">
    <div class="filter-box">
        @using (Html.BeginForm(nameof(RoomEscapeCatalog.Controllers.HomeController.Search), "Home", FormMethod.Get))
        {
            <div id="search-filter-container">
                <div class="filter-group">
                    <p>
                        <label for="difficulty-range">Difficulty:</label>
                        <span id="difficulty-values" class="filter-value"></span>
                        <input type="hidden" id="difficulty-min-val" name="difficultyMin">
                        <input type="hidden" id="difficulty-max-val" name="difficultyMax">
                    </p>
                    <div id="difficulty-range"></div>
                </div>

                <div class="filter-group">
                    <p>
                        <label for="creepiness-range">Creepiness:</label>
                        <span id="creepiness-values" class="filter-value"></span>
                        <input type="hidden" id="creepiness-min-val" name="creepinessMin">
                        <input type="hidden" id="creepiness-max-val" name="creepinessMax">
                    </p>
                    <div id="creepiness-range"></div>
                </div>

                <div class="filter-group">
                    <p>
                        <label for="group-size-range">Group size:</label>
                        <span id="group-size-values" class="filter-value"></span>
                        <input type="hidden" id="group-min-val" name="groupSizeMin">
                        <input type="hidden" id="group-max-val" name="groupSizeMax">
                    </p>
                    <div id="group-size-range"></div>
                </div>
            </div>
            <input type="submit" value="Search" class="btn btn-outline-dark" />
        }
    </div>

    <div class="d-flex flex-column">
        @foreach (var room in Model)
        {
            @DeclarativeHtmlHelpers.RoomCatalogItem(room)
        }
    </div>
</div>

@section scripts
{
    <script>
        let difficultySlider = $("#difficulty-range");
        let creepinessSlider = $("#creepiness-range");
        let groupSizeSlider = $("#group-size-range");

        // difficulty slider
        difficultySlider.slider({
            range: true,
            min: 1,
            max: 5,
            values: [@difficultyMinVal, @difficultyMaxVal],
            slide: function (event, ui) {
                $("#difficulty-values").text(`${ui.values[0]} - ${ui.values[1]}`);
                $("#difficulty-min-val").val(`${ui.values[0]}`);
                $("#difficulty-max-val").val(`${ui.values[1]}`);
            }
        });
        // difficulty - initial values
        $("#difficulty-values").text(`${difficultySlider.slider("values", 0)} - ${difficultySlider.slider("values", 1)}`);
        $("#difficulty-min-val").val(`${difficultySlider.slider("values", 0)}`);
        $("#difficulty-max-val").val(`${difficultySlider.slider("values", 1)}`);


        // creepiness slider
        creepinessSlider.slider({
            range: true,
            min: 1,
            max: 5,
            values: [@creepinessMinVal, @creepinessMaxVal],
            slide: function (event, ui) {
                $("#creepiness-values").text(`${ui.values[0]} - ${ui.values[1]}`);
                $("#creepiness-min-val").val(`${ui.values[0]}`);
                $("#creepiness-max-val").val(`${ui.values[1]}`);
            }
        });
        // creepiness - initial values
        $("#creepiness-values").text(`${creepinessSlider.slider("values", 0)} - ${creepinessSlider.slider("values", 1)}`);
        $("#creepiness-min-val").val(`${creepinessSlider.slider("values", 0)}`);
        $("#creepiness-max-val").val(`${creepinessSlider.slider("values", 1)}`);


        // group-size slider
        groupSizeSlider.slider({
            range: true,
            min: 1,
            max: 20,
            values: [@groupSizeMinVal, @groupSizeMaxVal],
            slide: function (event, ui) {
                $("#group-size-values").text(`${ui.values[0]} - ${ui.values[1]}`);
                $("#group-min-val").val(`${ui.values[0]}`);
                $("#group-max-val").val(`${ui.values[1]}`);
            }
        });
        // group-size - initial values
        $("#group-size-values").text(`${groupSizeSlider.slider("values", 0)} - ${groupSizeSlider.slider("values", 1)}`);
        $("#group-min-val").val(`${groupSizeSlider.slider("values", 0)}`);
        $("#group-max-val").val(`${groupSizeSlider.slider("values", 1)}`);
    </script>
}